using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System.Data.SqlClient;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;
using System.Reflection;
using Exferia_Aplicacion.Modelos_Generales;
using System.Data;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_Partes_TrabajosRealizados_Firmas_Datos 
    {

        #region MODELOS

        #region Modelo Simple
        private MYT_Partes_TrabajosRealizados_Firmas g_mdl_MYT_Partes_TrabajosRealizados_Firmas = null;
        public MYT_Partes_TrabajosRealizados_Firmas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MYT_Partes_TrabajosRealizados_Firmas) + "." + nameof(MYT_Partes_TrabajosRealizados_Firmas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MYT_Partes_TrabajosRealizados_Firmas;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_MYT_Partes_TrabajosRealizados_Firmas = obj_Exferia_Entities.Database.SqlQuery<MYT_Partes_TrabajosRealizados_Firmas>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion
        #endregion

        #region Modelo Listado
        private List<MYT_Partes_TrabajosRealizados_Firmas> g_lst_MYT_Partes_TrabajosRealizados_Firmas = null;

        public List<MYT_Partes_TrabajosRealizados_Firmas> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids,
                                                                                        bool _bol_Cargar_Tecnicos)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {

                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MYT_Partes_TrabajosRealizados_Firmas),
                                                                                            nameof(MYT_Partes_TrabajosRealizados_Firmas.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    new object[] { },
                                                    _bol_Cargar_Tecnicos);

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MYT_Partes_TrabajosRealizados_Firmas;
        }
        public List<MYT_Partes_TrabajosRealizados_Firmas> Obtener_ModeloListado_Por_IdTrabajoRealizado(long _lng_idTrabajoRealizado,
                                                                                                      bool _bol_Cargar_Tecnicos)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MYT_Partes_TrabajosRealizados_Firmas) + "." + nameof(MYT_Partes_TrabajosRealizados_Firmas.idTrabajoRealizado) + "=@idTrabajoRealizado";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idTrabajoRealizado",  _lng_idTrabajoRealizado)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                arr_Parametros,
                                                _bol_Cargar_Tecnicos);

                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdTrabajoRealizado), true);
            }

            return g_lst_MYT_Partes_TrabajosRealizados_Firmas;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<MYT_Tecnicos> g_lst_MYT_Tecnicos = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_Tecnicos)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MYT_Partes_TrabajosRealizados_Firmas = obj_Exferia_Entities.Database.SqlQuery<MYT_Partes_TrabajosRealizados_Firmas>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_MYT_Partes_TrabajosRealizados_Firmas != null && 
                    g_lst_MYT_Partes_TrabajosRealizados_Firmas.Count > 0)
                {
                    #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                    }

                    //MYT_Tecnicos ############################################# 
                    if (_bol_Cargar_Tecnicos)
                    {
                        ThreadStart obj_ThreadStart_TECNICOS = new ThreadStart(Obtener_Tecnicos_Modelo_Listado);
                        Thread obj_Thread_TECNICOS = new Thread(obj_ThreadStart_TECNICOS);
                        obj_Thread_TECNICOS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................

                    #endregion

                    #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                    foreach (MYT_Partes_TrabajosRealizados_Firmas mdl_MYT_Partes_TrabajosRealizados_Firmas in g_lst_MYT_Partes_TrabajosRealizados_Firmas)
                    {
                        //MYT_Tecnicos #############################################
                        if (_bol_Cargar_Tecnicos &&
                            mdl_MYT_Partes_TrabajosRealizados_Firmas.idTecnico_Firma != null &&
                            g_lst_MYT_Tecnicos != null &&
                            g_lst_MYT_Tecnicos.Count > 0)
                        {
                            mdl_MYT_Partes_TrabajosRealizados_Firmas.MYT_Tecnicos = g_lst_MYT_Tecnicos.Where(m => m.id == mdl_MYT_Partes_TrabajosRealizados_Firmas.idTecnico_Firma.Value).FirstOrDefault();
                        }
                    }
                    #endregion

                }

                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #region TablasRelacionadas
        private void Obtener_Tecnicos_Modelo_Listado()
        {
            try
            {
                MYT_Tecnicos_Datos obj_MYT_Tecnicos_Datos = new MYT_Tecnicos_Datos();
                g_lst_MYT_Tecnicos=obj_MYT_Tecnicos_Datos.Obtener_ModeloListado_Por_Ids(g_lst_MYT_Partes_TrabajosRealizados_Firmas.Where(m=>m.idTecnico_Firma!=null).Select(m=>m.idTecnico_Firma.Value).ToList(),false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.id) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.idTrabajoRealizado) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.idTerminal) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.idTecnico_Firma) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.tecnicoPrincipal) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.cliente_Firma) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.firma) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.observaciones) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.guid) + " , " +
                    nameof(MYT_Partes_TrabajosRealizados_Firmas.fechaBorrado) + 
                " FROM " + nameof(MYT_Partes_TrabajosRealizados_Firmas);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Insertar(MYT_Partes_TrabajosRealizados_Firmas _mdl_MYT_Partes_TrabajosRealizados_Firmas_AGrabar)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_Partes_TrabajosRealizados_Firmas mdl_MYT_Partes_TrabajosRealizados_Firmas_DatosViejos = new MYT_Partes_TrabajosRealizados_Firmas();

                // Ver si existe ######################################################################
                MYT_Partes_TrabajosRealizados_Firmas mdl_MYT_Partes_TrabajosRealizados_Firmas_Final = Obtener_Modelo_Por_Id(_mdl_MYT_Partes_TrabajosRealizados_Firmas_AGrabar.id);
                //#####################################################################################

                mdl_MYT_Partes_TrabajosRealizados_Firmas_Final = new MYT_Partes_TrabajosRealizados_Firmas();

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                // Cargar los Datos del Modelo
                Funciones.CopiarPropiedadesObjetos(_mdl_MYT_Partes_TrabajosRealizados_Firmas_AGrabar, mdl_MYT_Partes_TrabajosRealizados_Firmas_Final, false, false);

                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(MYT_Partes_TrabajosRealizados_Firmas) +
                                            " (" +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.idTrabajoRealizado) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.idTerminal) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.idTecnico_Firma) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.tecnicoPrincipal) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.cliente_Firma) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.firma) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.observaciones) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.guid) + "," +
                                                    nameof(MYT_Partes_TrabajosRealizados_Firmas.fechaBorrado) + 
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(MYT_Partes_TrabajosRealizados_Firmas.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idTrabajoRealizado," +
                                                "@idTerminal," +
                                                "@idTecnico_Firma," +
                                                "@tecnicoPrincipal," +
                                                "@cliente_Firma," +
                                                "@firma," +
                                                "@observaciones," +
                                                "@guid," +
                                                "@fechaBorrado" +
                                            " ) ";

                //Parametros
                SqlParameter obj_SqlParameter_Firma = new SqlParameter("@firma", SqlDbType.Binary);
                if (mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.firma != null)
                { obj_SqlParameter_Firma.Value = mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.firma; }
                else
                { obj_SqlParameter_Firma.Value = DBNull.Value; }

                object[] arr_Parametros_Insert = new object[]
                {
                        new SqlParameter("@idTrabajoRealizado",  mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.idTrabajoRealizado),
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.idTerminal != null
                        ?   new SqlParameter("@idTerminal", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.idTerminal.Value)
                        :   new SqlParameter("@idTerminal",  DBNull.Value),
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.idTecnico_Firma != null
                        ?   new SqlParameter("@idTecnico_Firma", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.idTecnico_Firma.Value)
                        :   new SqlParameter("@idTecnico_Firma",  DBNull.Value),
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.tecnicoPrincipal != null
                        ?   new SqlParameter("@tecnicoPrincipal", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.tecnicoPrincipal)
                        :   new SqlParameter("@tecnicoPrincipal",  DBNull.Value),
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.cliente_Firma != null
                        ?   new SqlParameter("@cliente_Firma", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.cliente_Firma)
                        :   new SqlParameter("@cliente_Firma",  DBNull.Value),
                        obj_SqlParameter_Firma,
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.observaciones != null
                        ?   new SqlParameter("@observaciones", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.observaciones)
                        :   new SqlParameter("@observaciones",  DBNull.Value),
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.guid != null
                        ?   new SqlParameter("@guid", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.guid)
                        :   new SqlParameter("@guid",  DBNull.Value),
                        mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.fechaBorrado != null
                        ?   new SqlParameter("@fechaBorrado", mdl_MYT_Partes_TrabajosRealizados_Firmas_Final.fechaBorrado.Value)
                        :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                };
                #endregion

                //Id de la tabla
                mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_Partes_TrabajosRealizados_Firmas), mdl_MYT_Partes_TrabajosRealizados_Firmas_DatosViejos, mdl_MYT_Partes_TrabajosRealizados_Firmas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar

        public INTERNO_ValorDevuelto_Modelo Borrar_Por_IdTrabajoRealizado(long _lng_idTrabajoRealizado)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL = " DELETE FROM " + nameof(MYT_Partes_TrabajosRealizados_Firmas) +
                                 " WHERE " + nameof(MYT_Partes_TrabajosRealizados_Firmas.idTrabajoRealizado) + " =" + _lng_idTrabajoRealizado ;
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
  
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_TrabajosRealizados_Firmas_Datos) + "/" + nameof(Borrar_Por_IdTrabajoRealizado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
